let playerGear = 1;
let localPlayer = mp.players.local;
let ShiftNow = false;
let gearText = null;
let toggle = false;
let blockedClasses = [8, 14, 15, 16] // blocked vehicle classes for manual transmission

// Gear Manager
function setPlayerGear(state) {
    if (state) {
        if (playerGear < 5) {
            playerGear += 1;
        }
    } else {
        if (playerGear > -1) {
            playerGear -= 1;
        }
    }
}

function manualTransmission() {
    let vehicle = localPlayer.vehicle;

    if (!vehicle) { // reset manual settings
        playerGear = 1;
        toggle = false;
    } 

    if (vehicle && toggle) {
        let vehSpeed = vehicle.getSpeed();
        let FirstMax = 11.0;
        let SecondMax = 21.0;
        let ThirdMax = 31.0;
        let FourthMax = 40.5;

        // Ensures realistic gear
        if (vehSpeed > 0 && playerGear > -1) mp.game.controls.disableControlAction(27, 72, true);
        else if (playerGear === -1) mp.game.controls.disableControlAction(27, 71, true);

        if (playerGear !== -1 && mp.game.controls.isControlPressed(27, 72)) {
            if (vehSpeed > 0) {
                vehSpeed -= 1.0;
            } 
        };

        // Gears switching cases
        switch (playerGear) {
    
            // Neutral
            case 0:
                {
                    mp.game.controls.disableControlAction(27, 71, true);
                    mp.game.controls.disableControlAction(27, 72, true);
                }
                break;

            // Gear 1
            case 1:
                {
                    if (vehSpeed > FirstMax) {
                        vehicle.setMaxSpeed(vehSpeed);
                    } else {
                        vehicle.setMaxSpeed(FirstMax);
                    }
                    if (vehSpeed > FirstMax - 1) {
                        ShiftNow = true;
                    } else {
                        ShiftNow = false;
                    }
                }
                break;
            // Gear 2
            case 2:
                {
                    if (vehSpeed > SecondMax) {
                        vehicle.setMaxSpeed(vehSpeed);
                    } else {
                        vehicle.setMaxSpeed(SecondMax);
                    }
                    if (vehSpeed > SecondMax - 1) {
                        ShiftNow = true;
                    } else {
                        ShiftNow = false;
                    }
                }
                break;
            // Gear 3
            case 3:
                {
                    if (vehSpeed > ThirdMax) {
                        vehicle.setMaxSpeed(vehSpeed);
                    } else {
                        vehicle.setMaxSpeed(ThirdMax);
                    }
                    if (vehSpeed > ThirdMax - 1) {
                        ShiftNow = true;
                    } else {
                        ShiftNow = false;
                    }
                }
                break;
            // Gear 4
            case 4:
                {
                    if (vehSpeed > FourthMax) {
                        vehicle.setMaxSpeed(vehSpeed);
                    } else {
                        vehicle.setMaxSpeed(FourthMax);
                    }
                    if (vehSpeed > FourthMax - 1) {
                        ShiftNow = true;
                    } else {
                        ShiftNow = false;
                    }
                }
                break;
            // Gear 5
            case 5:
                {
                    let maxSpeed = mp.game.vehicle.getVehicleModelMaxSpeed(vehicle.model);
                    vehicle.setMaxSpeed(maxSpeed);
                    ShiftNow = false;
                }
        }

        // Gear safety checking
        if (playerGear === 2 && vehSpeed <= FirstMax - 2.1) {
            if (mp.game.controls.isControlPressed(27, 71)) {
                vehicle.setMaxSpeed(FirstMax);
                mp.game.graphics.notify('~r~Shifted ~w~ to fast');
            }
        } else if (playerGear === 3 && vehSpeed <= SecondMax - 2.1) {
            if (mp.game.controls.isControlPressed(27, 71)) {
                vehicle.setEngineOn(false, false, false);
                mp.game.graphics.notify('~r~Shifted ~w~ to fast');
            }
        } else if (playerGear === 4 && vehSpeed <= ThirdMax - 2.1) {
            if (mp.game.controls.isControlPressed(27, 71)) {
                vehicle.setEngineOn(false, false, false);
                mp.game.graphics.notify('~r~Shifted ~w~ to fast');
            }
        } else if (playerGear === 5 && vehSpeed <= FourthMax - 2.1) {
            if (mp.game.controls.isControlPressed(27, 71)) {
                vehicle.setEngineOn(false, false, false);
                mp.game.graphics.notify('~r~Shifted ~w~ to fast');
            }
        }

        if (playerGear !== 1 && vehicle.isStopped()) {
            if (mp.game.controls.isControlPressed(27, 71)) {
                vehicle.setEngineOn(false, false, false);
                mp.game.graphics.notify('~w~Engine ~r~ fail!');
            }
        }

        // Gear text manager
        switch (playerGear) {
            case 0:
                gearText = 'N';
                break;
            case -1:
                gearText = 'R';
                break;
            default:
                gearText = playerGear;
        };

        // Display hud manual transmission.
        if (gearText)
            mp.game.graphics.drawText(`Gear: ${gearText}`, [0.22, 0.8], {
                font: 0,
                color: [255, 255, 255, 185],
                scale: [0.35, 0.35],
                outline: false
            });

        if (ShiftNow)
        mp.game.graphics.drawText(`ShiftNow`, [0.22, 0.83], {
            font: 0,
            color: [0, 255, 127, 185],
            scale: [0.35, 0.35],
            outline: false
        });

        mp.game.graphics.drawText(`${(vehSpeed * 3.6).toFixed(0)} KM/H`, [0.22, 0.86], {
            font: 0,
            color: [255, 255, 255, 185],
            scale: [0.35, 0.35],
            outline: false
        });

        mp.game.graphics.drawText(`Press ~g~NUMPAD_ADD ~w~to shift gear`, [0.27, 0.89], {
            font: 0,
            color: [255, 255, 255, 185],
            scale: [0.35, 0.35],
            outline: false
        });

        mp.game.graphics.drawText(`Press ~r~NUMPAD_SUBTRACT ~w~to lower gear`, [0.28, 0.92], {
            font: 0,
            color: [255, 255, 255, 185],
            scale: [0.35, 0.35],
            outline: false
        });
    }
};

//NUMPAD_ADD
mp.keys.bind(0x6B, false, function () {
    if (localPlayer.vehicle) setPlayerGear(true);
});

//NUMPAD_SUBTRACT
mp.keys.bind(0x6D, false, function () {
    if (localPlayer.vehicle) setPlayerGear(false);
});

mp.events.add('render', manualTransmission);
mp.events.add("playerCommand", (command) => {
	const args = command.split(/[ ]+/);
	const commandName = args.splice(0, 1)[0];
    let text;
    
    // toggle manual command
	if (commandName === "manual") {
        if (!localPlayer.vehicle) return mp.game.graphics.notify("You're not in a vehicle to toggle manual");
        if (!validVehicle(localPlayer.vehicle)) return mp.game.graphics.notify("You're not allowed to toggle manual on that vehicle type");
        toggle ? text = 'Manual has been ~r~disabled' : text = 'Manual has been ~g~enabled';
        toggle = !toggle; 
        mp.game.graphics.notify(text);
	} 
});

// Check vehicle class validity 
function validVehicle (vehicle) {
    let vehClass = mp.game.invoke('0x2006E750FCAB629D', vehicle.handle);
    if (blockedClasses.includes(vehClass)) return false;
    return true;
}